// ==========================================================================
// $Id: matrix3d.cpp,v 1.1 2013/11/06 17:22:55 jlang Exp $
// CSI2372 example Code for lecture 12
// ==========================================================================
// (C)opyright:
//
//   Jochen Lang
//   SITE, University of Ottawa
//   800 King Edward Ave.
//   Ottawa, On., K1N 6N5
//   Canada. 
//   http://www.site.uottawa.ca
// 
// Creator: jlang (Jochen Lang)
// Email:   jlang@site.uottawa.ca
// ==========================================================================
// $Log: matrix3d.cpp,v $
// Revision 1.1  2013/11/06 17:22:55  jlang
// Created templated vector example
//
// Revision 1.2  2006/11/20 21:34:06  jlang
// Added friend/inline/static demo
//

//
// ==========================================================================
#include <iostream>

#include "matrix3d.h"


// Initialize matrix to identity
Matrix3D::Matrix3D() 
{
  for ( int row=0; row<3; row++ ) {
    for ( int col=0; col<3; col++ ) {
      if ( row == col ) {
        d_elements[row*3+col] = 1.0f;
      } else {
        d_elements[row*3+col] = 0.0f;
      }
    }
  }
}
 
vec<double,3> Matrix3D::operator*( vec<double,3>& _vec ) { 
  vec<double,3> res;
  for ( int row=0; row<3; row++ ) {
    res(row) = 0.0; 
    for ( int col=0; col<3; col++ ) { 
      res(row) += d_elements[row*3+col] * _vec(col);
    }
  }
  return res;
}

ostream& operator<< ( ostream &os, const Matrix3D& _mat ) {
  for ( int row=0; row<3; row++ ) {
    os << "|";
    for ( int col=0; col<3; col++ ) {
      os << " " << _mat.d_elements[row*3+col];
    }
    os << " |" << endl;
  }
  return os;
}
